<?php
/**
 * $Horde: hermes/entry.php,v 1.4 2005/01/03 14:34:55 jan Exp $
 *
 * Copyright 2002-2005 Chuck Hagenbuch <chuck@horde.org>
 *
 * See the enclosed file LICENSE for license information (BSD). If you
 * did not receive this file, see http://www.horde.org/licenses/bsdl.php.
 */

@define('HERMES_BASE', dirname(__FILE__));
require_once HERMES_BASE . '/lib/base.php';
require_once HERMES_BASE . '/lib/TimeForm.php';
require_once 'Horde/Variables.php';

$vars = &Variables::getDefaultVariables();

switch ($vars->get('formname')) {
case 'timeentryform':
    $form = &Horde_Form::singleton('TimeEntryForm', $vars);
    $form->validate($vars);
    if ($form->isValid()) {
        $form->getInfo($vars, $info);
        if ($vars->exists('id')) {
            $msg = _("Your time was successfully updated.");
            $result = $hermes->updateTime(array($info));
        } else {
            $msg = _("Your time was successfully entered.");
            $result = $hermes->enterTime(Auth::getAuth(), $info);
        }
        if (is_a($result, 'PEAR_Error')) {
            Horde::logMessage($result, __FILE__, __LINE__, PEAR_LOG_ERR);
            $notification->push(sprintf(_("There was an error storing your timesheet: %s"), $result->getMessage()), 'horde.error');
        } else {
            $notification->push($msg, 'horde.success');
            header('Location: ' . Horde::applicationUrl('time.php'));
            exit;
        }
    }
    break;

default:
    if ($vars->exists('id')) {
        // We are updating a specific entry, load it into the form
        // variables.
        $id = $vars->get('id');
        $myhours = $hermes->getHours(array('id' => $id));
        if (is_array($myhours)) {
            foreach ($myhours as $item) {
                if (isset($item['id']) && $item['id'] == $id) {
                    foreach ($item as $key => $value) {
                        $vars->set($key, $value);
                    }
                }
            }
        }
    }
    break;
}

$title = _("Enter Time");
require HERMES_TEMPLATES . '/common-header.inc';
require HERMES_TEMPLATES . '/menu.inc';

$renderer = &new Horde_Form_Renderer();
$form = &Horde_Form::singleton('TimeEntryForm', $vars);
$form->renderActive($renderer, $vars, 'entry.php', 'post');

require $registry->get('templates', 'horde') . '/common-footer.inc';
